// +build windows

// mksyscall_windows.pl windows_syscall.go
// MACHINE GENERATED BY THE COMMAND ABOVE; DO NOT EDIT

package odbc3

import "unsafe"
import "syscall"

var (
	mododbc32 = syscall.NewLazyDLL("odbc32.dll")

	procSQLAllocHandle     = mododbc32.NewProc("SQLAllocHandle")
	procSQLFreeHandle      = mododbc32.NewProc("SQLFreeHandle")
	procSQLGetDiagRecW     = mododbc32.NewProc("SQLGetDiagRecW")
	procSQLSetEnvAttr      = mododbc32.NewProc("SQLSetEnvAttr")
	procSQLGetEnvAttr      = mododbc32.NewProc("SQLGetEnvAttr")
	procSQLSetConnectAttrW = mododbc32.NewProc("SQLSetConnectAttrW")
	procSQLGetConnectAttrW = mododbc32.NewProc("SQLGetConnectAttrW")
	procSQLDriversW        = mododbc32.NewProc("SQLDriversW")
	procSQLDataSourcesW    = mododbc32.NewProc("SQLDataSourcesW")
	procSQLConnectW        = mododbc32.NewProc("SQLConnectW")
	procSQLDriverConnectW  = mododbc32.NewProc("SQLDriverConnectW")
	procSQLExecDirectW     = mododbc32.NewProc("SQLExecDirectW")
	procSQLEndTran         = mododbc32.NewProc("SQLEndTran")
	procSQLFetch           = mododbc32.NewProc("SQLFetch")
	procSQLFetchScroll     = mododbc32.NewProc("SQLFetchScroll")
	procSQLPrepareW        = mododbc32.NewProc("SQLPrepareW")
	procSQLNumParams       = mododbc32.NewProc("SQLNumParams")
	procSQLNumResultCols   = mododbc32.NewProc("SQLNumResultCols")
	procSQLExecute         = mododbc32.NewProc("SQLExecute")
	procSQLColAttributeW   = mododbc32.NewProc("SQLColAttributeW")
	procSQLBindParameter   = mododbc32.NewProc("SQLBindParameter")
	procSQLGetData         = mododbc32.NewProc("SQLGetData")
	procSQLCancel          = mododbc32.NewProc("SQLCancel")
	procSQLRowCount        = mododbc32.NewProc("SQLRowCount")
)

func allocHandle(handleType HandleType, inputHandle unsafe.Pointer, outputHandle *unsafe.Pointer) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLAllocHandle.Addr(), 3, uintptr(handleType), uintptr(inputHandle), uintptr(unsafe.Pointer(outputHandle)))
	ret = sqlreturn(r0)
	return
}

func freeHandle(handleType HandleType, handle unsafe.Pointer) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLFreeHandle.Addr(), 2, uintptr(handleType), uintptr(handle), 0)
	ret = sqlreturn(r0)
	return
}

func getDiagRec(handleType HandleType, inputHandle unsafe.Pointer, recNumber int16, sqlState *uint16, nativeErrPtr *int32, messageText *uint16, bufferLength int16, textLengthPtr *int16) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall9(procSQLGetDiagRecW.Addr(), 8, uintptr(handleType), uintptr(inputHandle), uintptr(recNumber), uintptr(unsafe.Pointer(sqlState)), uintptr(unsafe.Pointer(nativeErrPtr)), uintptr(unsafe.Pointer(messageText)), uintptr(bufferLength), uintptr(unsafe.Pointer(textLengthPtr)), 0)
	ret = sqlreturn(r0)
	return
}

func setEnvAttr(handle *Environment, attribute int32, valuePtr unsafe.Pointer, stringLength int32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall6(procSQLSetEnvAttr.Addr(), 4, uintptr(unsafe.Pointer(handle)), uintptr(attribute), uintptr(valuePtr), uintptr(stringLength), 0, 0)
	ret = sqlreturn(r0)
	return
}

func getEnvAttr(handle *Environment, attribute int32, valuePtr unsafe.Pointer, bufferLength int32, stringLengthPtr *int32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall6(procSQLGetEnvAttr.Addr(), 5, uintptr(unsafe.Pointer(handle)), uintptr(attribute), uintptr(valuePtr), uintptr(bufferLength), uintptr(unsafe.Pointer(stringLengthPtr)), 0)
	ret = sqlreturn(r0)
	return
}

func setConnectAttr(handle *Connection, attribute int32, valuePtr unsafe.Pointer, stringLength int32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall6(procSQLSetConnectAttrW.Addr(), 4, uintptr(unsafe.Pointer(handle)), uintptr(attribute), uintptr(valuePtr), uintptr(stringLength), 0, 0)
	ret = sqlreturn(r0)
	return
}

func getConnectAttr(handle *Connection, attribute int32, valuePtr unsafe.Pointer, bufferLength int32, stringLengthPtr *int32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall6(procSQLGetConnectAttrW.Addr(), 5, uintptr(unsafe.Pointer(handle)), uintptr(attribute), uintptr(valuePtr), uintptr(bufferLength), uintptr(unsafe.Pointer(stringLengthPtr)), 0)
	ret = sqlreturn(r0)
	return
}

func drivers(handle *Environment, direction FetchDirection, driverDescription *uint16, bufferLength1 int16, descriptionLength *int16, attributes *uint16, bufferLength2 int16, attributesLength *int16) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall9(procSQLDriversW.Addr(), 8, uintptr(unsafe.Pointer(handle)), uintptr(direction), uintptr(unsafe.Pointer(driverDescription)), uintptr(bufferLength1), uintptr(unsafe.Pointer(descriptionLength)), uintptr(unsafe.Pointer(attributes)), uintptr(bufferLength2), uintptr(unsafe.Pointer(attributesLength)), 0)
	ret = sqlreturn(r0)
	return
}

func dataSources(handle *Environment, direction FetchDirection, driverDescription *uint16, bufferLength1 int16, descriptionLength *int16, attributes *uint16, bufferLength2 int16, attributesLength *int16) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall9(procSQLDataSourcesW.Addr(), 8, uintptr(unsafe.Pointer(handle)), uintptr(direction), uintptr(unsafe.Pointer(driverDescription)), uintptr(bufferLength1), uintptr(unsafe.Pointer(descriptionLength)), uintptr(unsafe.Pointer(attributes)), uintptr(bufferLength2), uintptr(unsafe.Pointer(attributesLength)), 0)
	ret = sqlreturn(r0)
	return
}

func connect(handle *Connection, serverName *uint16, nameLength1 int16, userName *uint16, nameLength2 int16, auth *uint16, nameLength3 int16) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall9(procSQLConnectW.Addr(), 7, uintptr(unsafe.Pointer(handle)), uintptr(unsafe.Pointer(serverName)), uintptr(nameLength1), uintptr(unsafe.Pointer(userName)), uintptr(nameLength2), uintptr(unsafe.Pointer(auth)), uintptr(nameLength3), 0, 0)
	ret = sqlreturn(r0)
	return
}

func driverConnect(handle *Connection, windowHandle unsafe.Pointer, inConnectionString *uint16, stringLength1 int16, outConnectionString *uint16, bufferLength int16, stringLength2Ptr *int16, driverCompletion DriverCompletion) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall9(procSQLDriverConnectW.Addr(), 8, uintptr(unsafe.Pointer(handle)), uintptr(windowHandle), uintptr(unsafe.Pointer(inConnectionString)), uintptr(stringLength1), uintptr(unsafe.Pointer(outConnectionString)), uintptr(bufferLength), uintptr(unsafe.Pointer(stringLength2Ptr)), uintptr(driverCompletion), 0)
	ret = sqlreturn(r0)
	return
}

func execDirect(handle *Statement, statementText *uint16, textLength int32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLExecDirectW.Addr(), 3, uintptr(unsafe.Pointer(handle)), uintptr(unsafe.Pointer(statementText)), uintptr(textLength))
	ret = sqlreturn(r0)
	return
}

func endTran(handleType HandleType, handle unsafe.Pointer, completionType CompletionType) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLEndTran.Addr(), 3, uintptr(handleType), uintptr(handle), uintptr(completionType))
	ret = sqlreturn(r0)
	return
}

func fetch(handle *Statement) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLFetch.Addr(), 1, uintptr(unsafe.Pointer(handle)), 0, 0)
	ret = sqlreturn(r0)
	return
}

func fetchScroll(handle *Statement, orientation FetchDirection, offset int32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLFetchScroll.Addr(), 3, uintptr(unsafe.Pointer(handle)), uintptr(orientation), uintptr(offset))
	ret = sqlreturn(r0)
	return
}

func prepare(handle *Statement, statementText *uint16, textLength int32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLPrepareW.Addr(), 3, uintptr(unsafe.Pointer(handle)), uintptr(unsafe.Pointer(statementText)), uintptr(textLength))
	ret = sqlreturn(r0)
	return
}

func numParams(handle *Statement, parameterCount *int16) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLNumParams.Addr(), 2, uintptr(unsafe.Pointer(handle)), uintptr(unsafe.Pointer(parameterCount)), 0)
	ret = sqlreturn(r0)
	return
}

func numResultCols(handle *Statement, parameterCount *int16) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLNumResultCols.Addr(), 2, uintptr(unsafe.Pointer(handle)), uintptr(unsafe.Pointer(parameterCount)), 0)
	ret = sqlreturn(r0)
	return
}

func execute(handle *Statement) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLExecute.Addr(), 1, uintptr(unsafe.Pointer(handle)), 0, 0)
	ret = sqlreturn(r0)
	return
}

func colAttribute(handle *Statement, index uint16, field FieldIdentifier, characterAttr *uint16, bufferLength int16, stringLength *int16, numericAttr *uint32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall9(procSQLColAttributeW.Addr(), 7, uintptr(unsafe.Pointer(handle)), uintptr(index), uintptr(field), uintptr(unsafe.Pointer(characterAttr)), uintptr(bufferLength), uintptr(unsafe.Pointer(stringLength)), uintptr(unsafe.Pointer(numericAttr)), 0, 0)
	ret = sqlreturn(r0)
	return
}

func bindParameter(handle *Statement, index uint16, inputOutputType int16, valueType int16, parameterType int16, columnSize uint32, decimalDigits int16, parameterValue unsafe.Pointer, bufferLength int32, stringLen *int32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall12(procSQLBindParameter.Addr(), 10, uintptr(unsafe.Pointer(handle)), uintptr(index), uintptr(inputOutputType), uintptr(valueType), uintptr(parameterType), uintptr(columnSize), uintptr(decimalDigits), uintptr(parameterValue), uintptr(bufferLength), uintptr(unsafe.Pointer(stringLen)), 0, 0)
	ret = sqlreturn(r0)
	return
}

func getData(handle *Statement, index uint16, targetType int16, targetValue unsafe.Pointer, bufferLength int32, stringLength *int32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall6(procSQLGetData.Addr(), 6, uintptr(unsafe.Pointer(handle)), uintptr(index), uintptr(targetType), uintptr(targetValue), uintptr(bufferLength), uintptr(unsafe.Pointer(stringLength)))
	ret = sqlreturn(r0)
	return
}

func cancel(handle *Statement) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLCancel.Addr(), 1, uintptr(unsafe.Pointer(handle)), 0, 0)
	ret = sqlreturn(r0)
	return
}

func rowCount(handle *Statement, rowCount *int32) (ret sqlreturn) {
	r0, _, _ := syscall.Syscall(procSQLRowCount.Addr(), 2, uintptr(unsafe.Pointer(handle)), uintptr(unsafe.Pointer(rowCount)), 0)
	ret = sqlreturn(r0)
	return
}
